#===============================================================================
# Copyright 2014-2017 Intel Corporation All Rights Reserved.
#
# The source code,  information  and material  ("Material") contained  herein is
# owned by Intel Corporation or its  suppliers or licensors,  and  title to such
# Material remains with Intel  Corporation or its  suppliers or  licensors.  The
# Material  contains  proprietary  information  of  Intel or  its suppliers  and
# licensors.  The Material is protected by  worldwide copyright  laws and treaty
# provisions.  No part  of  the  Material   may  be  used,  copied,  reproduced,
# modified, published,  uploaded, posted, transmitted,  distributed or disclosed
# in any way without Intel's prior express written permission.  No license under
# any patent,  copyright or other  intellectual property rights  in the Material
# is granted to  or  conferred  upon  you,  either   expressly,  by implication,
# inducement,  estoppel  or  otherwise.  Any  license   under such  intellectual
# property rights must be express and approved by Intel in writing.
#
# Unless otherwise agreed by Intel in writing,  you may not remove or alter this
# notice or  any  other  notice   embedded  in  Materials  by  Intel  or Intel's
# suppliers or licensors in any way.
#===============================================================================

## <a name="DAAL-EXAMPLE-PY-LOW_ORDER_MOMENTS_CSR_ONLINE"></a>
## \example low_order_moms_csr_online.py

from os import environ
from os.path import join as jp

from daal.algorithms.low_order_moments import (
    data, Online, minimum, maximum, sum, sumSquares, sumSquaresCentered,
    mean, secondOrderRawMoment, variance, standardDeviation, variation
)
import inspect, sys, os.path
utils_folder = os.path.realpath(os.path.abspath(jp(os.path.split(inspect.getfile(inspect.currentframe()))[0], "..")))
if utils_folder not in sys.path:
    sys.path.insert(0, utils_folder)
from utils import printNumericTable, createSparseTable

DAAL_PREFIX = jp('..', 'data')

# Input data set parameters
nBlocks = 4

datasetFileNames = [
    jp(DAAL_PREFIX, 'online', 'covcormoments_csr_1.csv'),
    jp(DAAL_PREFIX, 'online', 'covcormoments_csr_2.csv'),
    jp(DAAL_PREFIX, 'online', 'covcormoments_csr_3.csv'),
    jp(DAAL_PREFIX, 'online', 'covcormoments_csr_4.csv')
]


def printResults(res):
    printNumericTable(res.get(minimum),              "Minimum:")
    printNumericTable(res.get(maximum),              "Maximum:")
    printNumericTable(res.get(sum),                  "Sum:")
    printNumericTable(res.get(sumSquares),           "Sum of squares:")
    printNumericTable(res.get(sumSquaresCentered),   "Sum of squared difference from the means:")
    printNumericTable(res.get(mean),                 "Mean:")
    printNumericTable(res.get(secondOrderRawMoment), "Second order raw moment:")
    printNumericTable(res.get(variance),             "Variance:")
    printNumericTable(res.get(standardDeviation),    "Standard deviation:")
    printNumericTable(res.get(variation),            "Variation:")

if __name__ == "__main__":

    # Create algorithm objects for low order moments computing in online mode using default method
    algorithm = Online()

    for i in range(nBlocks):
        dataTable = createSparseTable(datasetFileNames[i])

        # Set input arguments of the algorithm
        algorithm.input.set(data, dataTable)

        # Compute partial low order moments estimates
        algorithm.compute()

    # Finalize online result and get computed low order moments
    res = algorithm.finalizeCompute()

    printResults(res)
